<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: SockServ.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">SockServ.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;</div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef MAIN_SOCKSERV_H_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define MAIN_SOCKSERV_H_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;set&gt;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;Socket.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;FreeRTOS.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;freertos/FreeRTOS.h&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;freertos/queue.h&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="classSockServ.html">   33</a></span>&#160;<span class="keyword">class </span><a class="code" href="classSockServ.html">SockServ</a> {</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> acceptTask(<span class="keywordtype">void</span>*);</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    uint16_t            m_port;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <a class="code" href="classSocket.html">Socket</a>              m_serverSocket;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a> m_clientSemaphore = <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a>(<span class="stringliteral">&quot;clientSemaphore&quot;</span>);</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    std::set&lt;Socket&gt;    m_clientSet;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    QueueHandle_t       m_acceptQueue;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keywordtype">bool</span>                m_useSSL;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <a class="code" href="classSockServ.html#a9fb32006f0a3a89da0145971a17ccab4">SockServ</a>(uint16_t port);</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <a class="code" href="classSockServ.html#a9fb32006f0a3a89da0145971a17ccab4">SockServ</a>();</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <a class="code" href="classSockServ.html#a18b87a413bac01b49e89f7d616a14da8">~SockServ</a>();</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keywordtype">int</span>    <a class="code" href="classSockServ.html#a74fdc3b3fcb84a1e64505b1c792032f9">connectedCount</a>();</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keywordtype">void</span>   <a class="code" href="classSockServ.html#a28ad7ac11058be8dbb87439c430329c2">disconnect</a>(<a class="code" href="classSocket.html">Socket</a> s);</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordtype">bool</span>   <a class="code" href="classSockServ.html#aa62641e571ccec4dd6ec8c141204fe5e">getSSL</a>();</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keywordtype">size_t</span> <a class="code" href="classSockServ.html#a9e4e21eb4e94912fd403a7e3dcbdb54c">receiveData</a>(<a class="code" href="classSocket.html">Socket</a> s, <span class="keywordtype">void</span>* pData, <span class="keywordtype">size_t</span> maxData);</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keywordtype">void</span>   <a class="code" href="classSockServ.html#a3e4e4cc30becc9440573c3285e8004d2">sendData</a>(uint8_t* data, <span class="keywordtype">size_t</span> length);</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keywordtype">void</span>   <a class="code" href="classSockServ.html#a3e4e4cc30becc9440573c3285e8004d2">sendData</a>(std::string str);</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keywordtype">void</span>   <a class="code" href="classSockServ.html#a12c8f4baa1bad7d405a39c4ad3310e37">setPort</a>(uint16_t port);</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordtype">void</span>   setSSL(<span class="keywordtype">bool</span> use = <span class="keyword">true</span>);</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordtype">void</span>   <a class="code" href="classSockServ.html#abbfb5d8eba2ef0a47fa0aa981a43f6dc">start</a>();</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keywordtype">void</span>   <a class="code" href="classSockServ.html#a4d6d90089cd108ba10e481e4aca274f4">stop</a>();</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <a class="code" href="classSocket.html">Socket</a> waitForData(std::set&lt;Socket&gt;&amp; socketSet);</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <a class="code" href="classSocket.html">Socket</a> <a class="code" href="classSockServ.html#ad0dfa6f354891c6f8b435d831fea14f5">waitForNewClient</a>();</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;};</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* MAIN_SOCKSERV_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classSocket_html"><div class="ttname"><a href="classSocket.html">Socket</a></div><div class="ttdoc">Encapsulate a socket.</div><div class="ttdef"><b>Definition:</b> Socket.h:62</div></div>
<div class="ttc" id="classSockServ_html_a28ad7ac11058be8dbb87439c430329c2"><div class="ttname"><a href="classSockServ.html#a28ad7ac11058be8dbb87439c430329c2">SockServ::disconnect</a></div><div class="ttdeci">void disconnect(Socket s)</div><div class="ttdoc">Disconnect any connected partners.</div><div class="ttdef"><b>Definition:</b> SockServ.cpp:96</div></div>
<div class="ttc" id="classSockServ_html_a18b87a413bac01b49e89f7d616a14da8"><div class="ttname"><a href="classSockServ.html#a18b87a413bac01b49e89f7d616a14da8">SockServ::~SockServ</a></div><div class="ttdeci">~SockServ()</div><div class="ttdef"><b>Definition:</b> SockServ.cpp:50</div></div>
<div class="ttc" id="classSockServ_html_abbfb5d8eba2ef0a47fa0aa981a43f6dc"><div class="ttname"><a href="classSockServ.html#abbfb5d8eba2ef0a47fa0aa981a43f6dc">SockServ::start</a></div><div class="ttdeci">void start()</div><div class="ttdoc">Start listening for new partner connections.</div><div class="ttdef"><b>Definition:</b> SockServ.cpp:168</div></div>
<div class="ttc" id="classSockServ_html_aa62641e571ccec4dd6ec8c141204fe5e"><div class="ttname"><a href="classSockServ.html#aa62641e571ccec4dd6ec8c141204fe5e">SockServ::getSSL</a></div><div class="ttdeci">bool getSSL()</div><div class="ttdef"><b>Definition:</b> SockServ.cpp:105</div></div>
<div class="ttc" id="classSockServ_html_a3e4e4cc30becc9440573c3285e8004d2"><div class="ttname"><a href="classSockServ.html#a3e4e4cc30becc9440573c3285e8004d2">SockServ::sendData</a></div><div class="ttdeci">void sendData(uint8_t *data, size_t length)</div><div class="ttdoc">Send data to any connected partners.</div><div class="ttdef"><b>Definition:</b> SockServ.cpp:142</div></div>
<div class="ttc" id="classSockServ_html_a12c8f4baa1bad7d405a39c4ad3310e37"><div class="ttname"><a href="classSockServ.html#a12c8f4baa1bad7d405a39c4ad3310e37">SockServ::setPort</a></div><div class="ttdeci">void setPort(uint16_t port)</div><div class="ttdoc">Set the port number to use.</div><div class="ttdef"><b>Definition:</b> SockServ.cpp:153</div></div>
<div class="ttc" id="classSockServ_html_a9e4e21eb4e94912fd403a7e3dcbdb54c"><div class="ttname"><a href="classSockServ.html#a9e4e21eb4e94912fd403a7e3dcbdb54c">SockServ::receiveData</a></div><div class="ttdeci">size_t receiveData(Socket s, void *pData, size_t maxData)</div><div class="ttdoc">Wait for data.</div><div class="ttdef"><b>Definition:</b> SockServ.cpp:116</div></div>
<div class="ttc" id="classSockServ_html_ad0dfa6f354891c6f8b435d831fea14f5"><div class="ttname"><a href="classSockServ.html#ad0dfa6f354891c6f8b435d831fea14f5">SockServ::waitForNewClient</a></div><div class="ttdeci">Socket waitForNewClient()</div><div class="ttdoc">Wait for a client connection to be present. Returns when a client connection is present....</div><div class="ttdef"><b>Definition:</b> SockServ.cpp:228</div></div>
<div class="ttc" id="classSockServ_html_a9fb32006f0a3a89da0145971a17ccab4"><div class="ttname"><a href="classSockServ.html#a9fb32006f0a3a89da0145971a17ccab4">SockServ::SockServ</a></div><div class="ttdeci">SockServ()</div><div class="ttdef"><b>Definition:</b> SockServ.cpp:39</div></div>
<div class="ttc" id="classFreeRTOS_1_1Semaphore_html"><div class="ttname"><a href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a></div><div class="ttdef"><b>Definition:</b> FreeRTOS.h:31</div></div>
<div class="ttc" id="classSockServ_html_a4d6d90089cd108ba10e481e4aca274f4"><div class="ttname"><a href="classSockServ.html#a4d6d90089cd108ba10e481e4aca274f4">SockServ::stop</a></div><div class="ttdeci">void stop()</div><div class="ttdoc">Stop listening for new partner connections.</div><div class="ttdef"><b>Definition:</b> SockServ.cpp:180</div></div>
<div class="ttc" id="classSockServ_html"><div class="ttname"><a href="classSockServ.html">SockServ</a></div><div class="ttdoc">Provide a socket listener and the ability to send data to connected partners.</div><div class="ttdef"><b>Definition:</b> SockServ.h:33</div></div>
<div class="ttc" id="classSockServ_html_a74fdc3b3fcb84a1e64505b1c792032f9"><div class="ttname"><a href="classSockServ.html#a74fdc3b3fcb84a1e64505b1c792032f9">SockServ::connectedCount</a></div><div class="ttdeci">int connectedCount()</div><div class="ttdoc">Determine the number of connected partners.</div><div class="ttdef"><b>Definition:</b> SockServ.cpp:88</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
